Package org.apache.commons.math3.geometry.euclidean.oned

# Class IntervalsSet

java.lang.Object
org.apache.commons.math3.geometry.partitioning.AbstractRegion<Euclidean1D,Euclidean1D>
org.apache.commons.math3.geometry.euclidean.oned.IntervalsSet

All Implemented Interfaces:
  `Iterable<double[]>`, `Region<Euclidean1D>`

public class IntervalsSet extends AbstractRegion<Euclidean1D,Euclidean1D> implements Iterable<double[]>
This class represents a 1D region: a set of intervals.

Since:
  3.0

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.apache.commons.math3.geometry.partitioning.Region

`Region.Location`

## Constructor Summary

Constructors
Constructor
Description
`IntervalsSet()`
Deprecated.
as of 3.1 replaced with `IntervalsSet(double)`
`IntervalsSet(double tolerance)`
Build an intervals set representing the whole real line.
`IntervalsSet(double lower, double upper)`
Deprecated.
as of 3.3 replaced with `IntervalsSet(double, double, double)`
`IntervalsSet(double lower, double upper, double tolerance)`
Build an intervals set corresponding to a single interval.
`IntervalsSet(Collection<SubHyperplane<Euclidean1D>> boundary)`
Deprecated.
as of 3.3, replaced with `IntervalsSet(Collection, double)`
`IntervalsSet(Collection<SubHyperplane<Euclidean1D>> boundary, double tolerance)`
Build an intervals set from a Boundary REPresentation (B-rep).
`IntervalsSet(BSPTree<Euclidean1D> tree)`
Deprecated.
as of 3.3, replaced with `IntervalsSet(BSPTree, double)`
`IntervalsSet(BSPTree<Euclidean1D> tree, double tolerance)`
Build an intervals set from an inside/outside BSP tree.

## Method Summary

Modifier and Type
Method
Description
`List<Interval>`
`asList()`
Build an ordered list of intervals representing the instance.
`IntervalsSet`
`buildNew(BSPTree<Euclidean1D> tree)`
Build a region using the instance as a prototype.
`protected void`
`computeGeometricalProperties()`
Compute some geometrical properties.
`double`
`getInf()`
Get the lowest value belonging to the instance.
`double`
`getSup()`
Get the highest value belonging to the instance.
`Iterator<double[]>`
`iterator()`
`BoundaryProjection<Euclidean1D>`
`projectToBoundary(Point<Euclidean1D> point)`
Project a point on the boundary of the region.

### Methods inherited from class org.apache.commons.math3.geometry.partitioning.AbstractRegion

`applyTransform, checkPoint, checkPoint, checkPoint, checkPoint, contains, copySelf, getBarycenter, getBoundarySize, getSize, getTolerance, getTree, intersection, isEmpty, isEmpty, isFull, isFull, setBarycenter, setBarycenter, setSize, side`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.lang.Iterable

`forEach, spliterator`

## Constructor Details

### IntervalsSet

public IntervalsSet(double tolerance)
Build an intervals set representing the whole real line.

Parameters:
  `tolerance` - tolerance below which points are considered identical.
Since:
  3.3

### IntervalsSet

public IntervalsSet(double lower, double upper, double tolerance)
Build an intervals set corresponding to a single interval.

Parameters:
  `lower` - lower bound of the interval, must be lesser or equal to `upper` (may be `Double.NEGATIVE_INFINITY`)
  `upper` - upper bound of the interval, must be greater or equal to `lower` (may be `Double.POSITIVE_INFINITY`)
  `tolerance` - tolerance below which points are considered identical.
Since:
  3.3

### IntervalsSet

public IntervalsSet(BSPTree<Euclidean1D> tree, double tolerance)
Build an intervals set from an inside/outside BSP tree.

The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`

Parameters:
  `tree` - inside/outside BSP tree representing the intervals set
  `tolerance` - tolerance below which points are considered identical.
Since:
  3.3

### IntervalsSet

public IntervalsSet(Collection<SubHyperplane<Euclidean1D>> boundary, double tolerance)
Build an intervals set from a Boundary REPresentation (B-rep).

The boundary is provided as a collection of `sub-hyperplanes`. Each sub-hyperplane has the interior part of the region on its minus side and the exterior on its plus side.

The boundary elements can be in any order, and can form several non-connected sets (like for example polygons with holes or a set of disjoints polyhedrons considered as a whole). In fact, the elements do not even need to be connected together (their topological connections are not used here). However, if the boundary does not really separate an inside open from an outside open (open having here its topological meaning), then subsequent calls to the `checkPoint` method will not be meaningful anymore.

If the boundary is empty, the region will represent the whole space.

Parameters:
  `boundary` - collection of boundary elements
  `tolerance` - tolerance below which points are considered identical.
Since:
  3.3

### IntervalsSet

@Deprecated public IntervalsSet()
Deprecated.
as of 3.1 replaced with `IntervalsSet(double)`
Build an intervals set representing the whole real line.

### IntervalsSet

@Deprecated public IntervalsSet(double lower, double upper)
Deprecated.
as of 3.3 replaced with `IntervalsSet(double, double, double)`
Build an intervals set corresponding to a single interval.

Parameters:
  `lower` - lower bound of the interval, must be lesser or equal to `upper` (may be `Double.NEGATIVE_INFINITY`)
  `upper` - upper bound of the interval, must be greater or equal to `lower` (may be `Double.POSITIVE_INFINITY`)

### IntervalsSet

@Deprecated public IntervalsSet(BSPTree<Euclidean1D> tree)
Deprecated.
as of 3.3, replaced with `IntervalsSet(BSPTree, double)`
Build an intervals set from an inside/outside BSP tree.

The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`

Parameters:
  `tree` - inside/outside BSP tree representing the intervals set

### IntervalsSet

@Deprecated public IntervalsSet(Collection<SubHyperplane<Euclidean1D>> boundary)
Deprecated.
as of 3.3, replaced with `IntervalsSet(Collection, double)`
Build an intervals set from a Boundary REPresentation (B-rep).

The boundary is provided as a collection of `sub-hyperplanes`. Each sub-hyperplane has the interior part of the region on its minus side and the exterior on its plus side.

The boundary elements can be in any order, and can form several non-connected sets (like for example polygons with holes or a set of disjoints polyhedrons considered as a whole). In fact, the elements do not even need to be connected together (their topological connections are not used here). However, if the boundary does not really separate an inside open from an outside open (open having here its topological meaning), then subsequent calls to the `checkPoint` method will not be meaningful anymore.

If the boundary is empty, the region will represent the whole space.

Parameters:
  `boundary` - collection of boundary elements

## Method Details

### buildNew

public IntervalsSet buildNew(BSPTree<Euclidean1D> tree)
Build a region using the instance as a prototype.

This method allow to create new instances without knowing exactly the type of the region. It is an application of the prototype design pattern.

The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`. The tree also must have either null internal nodes or internal nodes representing the boundary as specified in the `getTree` method).

Specified by:
  `buildNew` in interface `Region<Euclidean1D>`
Specified by:
  `buildNew` in class `AbstractRegion<Euclidean1D,Euclidean1D>`
Parameters:
  `tree` - inside/outside BSP tree representing the new region
Returns:
  the built region

### computeGeometricalProperties

protected void computeGeometricalProperties()
Compute some geometrical properties.

The properties to compute are the barycenter and the size.

Specified by:
  `computeGeometricalProperties` in class `AbstractRegion<Euclidean1D,Euclidean1D>`

### getInf

public double getInf()
Get the lowest value belonging to the instance.

Returns:
  lowest value belonging to the instance (`Double.NEGATIVE_INFINITY` if the instance doesn't have any low bound, `Double.POSITIVE_INFINITY` if the instance is empty)

### getSup

public double getSup()
Get the highest value belonging to the instance.

Returns:
  highest value belonging to the instance (`Double.POSITIVE_INFINITY` if the instance doesn't have any high bound, `Double.NEGATIVE_INFINITY` if the instance is empty)

### projectToBoundary

public BoundaryProjection<Euclidean1D> projectToBoundary(Point<Euclidean1D> point)
Project a point on the boundary of the region.

Specified by:
  `projectToBoundary` in interface `Region<Euclidean1D>`
Overrides:
  `projectToBoundary` in class `AbstractRegion<Euclidean1D,Euclidean1D>`
Parameters:
  `point` - point to check
Returns:
  projection of the point on the boundary
Since:
  3.3

### asList

public List<Interval> asList()
Build an ordered list of intervals representing the instance.

This method builds this intervals set as an ordered list of `Interval` elements. If the intervals set has no lower limit, the first interval will have its low bound equal to `Double.NEGATIVE_INFINITY`. If the intervals set has no upper limit, the last interval will have its upper bound equal to `Double.POSITIVE_INFINITY`. An empty tree will build an empty list while a tree representing the whole real line will build a one element list with both bounds being infinite.

Returns:
  a new ordered list containing `Interval` elements

### iterator

public Iterator<double[]> iterator()

The iterator returns the limit values of sub-intervals in ascending order.

The iterator does not support the optional `remove` operation.

Specified by:
  `iterator` in interface `Iterable<double[]>`
Since:
  3.3